import { defineComponent as M, computed as S, createElementBlock as a, openBlock as n, normalizeClass as $, createCommentVNode as x, renderSlot as w, createTextVNode as ne, createElementVNode as t, Fragment as y, renderList as _, toDisplayString as b, ref as k, h as te, onMounted as F, watch as E, withDirectives as U, createVNode as W, isRef as Te, vModelCheckbox as Me, unref as V, defineAsyncComponent as Be, onBeforeUnmount as Ie, normalizeStyle as Oe, createBlock as re, resolveDynamicComponent as ie, mergeProps as ue, nextTick as de, onUnmounted as pe, vModelSelect as j, vModelText as ee } from "vue";
const Ue = {
  key: 0,
  class: "loading loading-spinner"
}, gn = /* @__PURE__ */ M({
  __name: "ButtonComponent",
  props: {
    outlined: { type: Boolean, default: !1 },
    active: { type: Boolean, default: !1 },
    loading: { type: Boolean, default: !1 },
    type: {},
    size: {},
    shape: {}
  },
  setup(d) {
    const u = d, e = S(() => {
      switch (u.size) {
        case "large":
          return "btn-lg";
        case "small":
          return "btn-sm";
        case "tiny":
          return "btn-tiny";
        case "wide":
          return "btn-wide";
        case "full":
          return "w-full";
        default:
          return "";
      }
    }), s = S(() => {
      switch (u.type) {
        case "neutral":
          return "btn-neutral";
        case "primary":
          return "btn-primary";
        case "secondary":
          return "btn-secondary";
        case "accent":
          return "btn-accent";
        case "ghost":
          return "btn-ghost";
        case "link":
          return "btn-link px-0!";
        case "info":
          return "btn-info";
        case "success":
          return "btn-success";
        case "warning":
          return "btn-warning";
        case "error":
          return "btn-error";
        default:
          return "btn-neutral";
      }
    }), i = S(() => {
      switch (u.shape) {
        case "square":
          return "btn-square";
        case "circle":
          return "btn-circle";
        default:
          return "";
      }
    });
    return (l, p) => (n(), a("button", {
      class: $(["btn", { "btn-outline": u.outlined }, { "btn-active": u.active }, s.value, e.value, i.value])
    }, [
      l.loading ? (n(), a("span", Ue)) : x("", !0),
      w(l.$slots, "default", {}, () => [
        p[0] || (p[0] = ne("Submit"))
      ])
    ], 2));
  }
}), Ve = {
  tabindex: "0",
  class: "z-1 bg-base-100 shadow-sm p-2 rounded-sm min-w-[inherit] md:min-w-full xl:min-w-52 dropdown-content menu"
}, Ae = ["href"], hn = /* @__PURE__ */ M({
  __name: "dropdown",
  props: {
    items: {},
    position: { default: "bottom" },
    floatPosition: { default: "start" },
    openOnHover: { type: Boolean, default: !1 },
    forceOpen: { type: Boolean, default: !1 }
  },
  setup(d) {
    const u = {
      left: "dropdown-left",
      right: "dropdown-right",
      bottom: "dropdown-bottom",
      top: "dropdown-top"
    }, e = {
      start: "",
      end: "dropdown-end"
    }, s = d;
    return (i, l) => (n(), a("div", {
      class: $(["dropdown", u[s.position], e[s.floatPosition], { "dropdown-open": s.forceOpen }, { "dropdown-hover": s.openOnHover }])
    }, [
      w(i.$slots, "default", {
        tabindex: "0",
        role: "button"
      }, () => [
        l[0] || (l[0] = t("div", { class: "m-1 btn" }, "Open dropdown", -1))
      ]),
      t("ul", Ve, [
        (n(!0), a(y, null, _(i.items, (p) => (n(), a("li", null, [
          t("a", {
            href: p.link
          }, b(p.text), 9, Ae)
        ]))), 256)),
        w(i.$slots, "additional")
      ])
    ], 2));
  }
}), Pe = { class: "modal-box" }, je = { class: "modal-action" }, bn = /* @__PURE__ */ M({
  __name: "modal",
  props: {
    position: { default: "center" },
    withBackdrop: { type: Boolean, default: !1 }
  },
  setup(d) {
    const u = d, e = {
      top: "modal-top",
      bottom: "modal-bottom",
      center: "modal-middle"
    }, s = k(null), i = () => {
      var p;
      (p = s.value) == null || p.showModal();
    }, l = () => {
      var p;
      (p = s.value) == null || p.close();
    };
    return (p, h) => (n(), a(y, null, [
      t("span", {
        class: "w-fit cursor-pointer",
        onClick: i
      }, [
        w(p.$slots, "trigger", { role: "button" }, () => [
          h[0] || (h[0] = t("button", { class: "btn" }, "Open", -1))
        ])
      ]),
      t("dialog", {
        ref_key: "dialog",
        ref: s,
        class: $(["modal", e[u.position]])
      }, [
        t("div", Pe, [
          w(p.$slots, "default"),
          t("div", je, [
            w(p.$slots, "actions"),
            t("form", {
              method: "dialog",
              onSubmit: l,
              class: $(p.withBackdrop ? "modal-backdrop" : "")
            }, [
              w(p.$slots, "close-button", {}, () => [
                h[1] || (h[1] = t("button", { class: "btn" }, "Close", -1))
              ])
            ], 34)
          ])
        ])
      ], 2)
    ], 64));
  }
}), ze = { class: "swap-on" }, Ne = { class: "swap-off" }, yn = /* @__PURE__ */ M({
  __name: "swap",
  props: {
    effect: {}
  },
  setup(d) {
    const u = d;
    return (e, s) => (n(), a("label", {
      class: $(["swap", u.effect ? `swap-${e.effect}` : ""])
    }, [
      s[0] || (s[0] = t("input", { type: "checkbox" }, null, -1)),
      t("div", ze, [
        w(e.$slots, "on")
      ]),
      t("div", Ne, [
        w(e.$slots, "off")
      ])
    ], 2));
  }
});
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const Ee = (d) => d.replace(/([a-z0-9])([A-Z])/g, "$1-$2").toLowerCase();
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
var J = {
  xmlns: "http://www.w3.org/2000/svg",
  width: 24,
  height: 24,
  viewBox: "0 0 24 24",
  fill: "none",
  stroke: "currentColor",
  "stroke-width": 2,
  "stroke-linecap": "round",
  "stroke-linejoin": "round"
};
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const Le = ({ size: d, strokeWidth: u = 2, absoluteStrokeWidth: e, color: s, iconNode: i, name: l, class: p, ...h }, { slots: f }) => te(
  "svg",
  {
    ...J,
    width: d || J.width,
    height: d || J.height,
    stroke: s || J.stroke,
    "stroke-width": e ? Number(u) * 24 / Number(d) : u,
    class: ["lucide", `lucide-${Ee(l ?? "icon")}`],
    ...h
  },
  [...i.map((m) => te(...m)), ...f.default ? [f.default()] : []]
);
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const ae = (d, u) => (e, { slots: s }) => te(
  Le,
  {
    ...e,
    iconNode: u,
    name: d
  },
  s
);
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const Re = ae("MoonIcon", [
  ["path", { d: "M12 3a6 6 0 0 0 9 9 9 9 0 1 1-9-9Z", key: "a7tn18" }]
]);
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const ce = ae("SearchIcon", [
  ["circle", { cx: "11", cy: "11", r: "8", key: "4ej97u" }],
  ["path", { d: "m21 21-4.3-4.3", key: "1qie3q" }]
]);
/**
 * @license lucide-vue-next v0.468.0 - ISC
 *
 * This source code is licensed under the ISC license.
 * See the LICENSE file in the root directory of this source tree.
 */
const Fe = ae("SunIcon", [
  ["circle", { cx: "12", cy: "12", r: "4", key: "4exip2" }],
  ["path", { d: "M12 2v2", key: "tus03m" }],
  ["path", { d: "M12 20v2", key: "1lh1kg" }],
  ["path", { d: "m4.93 4.93 1.41 1.41", key: "149t6j" }],
  ["path", { d: "m17.66 17.66 1.41 1.41", key: "ptbguv" }],
  ["path", { d: "M2 12h2", key: "1t8f8n" }],
  ["path", { d: "M20 12h2", key: "1q8mjw" }],
  ["path", { d: "m6.34 17.66-1.41 1.41", key: "1m8zz5" }],
  ["path", { d: "m19.07 4.93-1.41 1.41", key: "1shlcs" }]
]), He = (d, u) => {
  const e = k(null);
  return F(() => {
    if (typeof window < "u") {
      const s = window.localStorage.getItem(d);
      e.value = s ? JSON.parse(s) : u;
    }
  }), E(e, (s) => {
    typeof window < "u" && window.localStorage.setItem(d, JSON.stringify(s));
  }), e;
}, qe = { class: "swap-rotate swap" }, Ye = ["true-value", "false-value"], wn = /* @__PURE__ */ M({
  __name: "theme-controller",
  props: {
    lightTheme: { default: "light" },
    darkTheme: { default: "dark" }
  },
  setup(d) {
    const u = d, e = He("theme", u.lightTheme);
    function s(i) {
      typeof window < "u" && window.document && document.documentElement.setAttribute("data-theme", i);
    }
    return F(() => s(e.value ? e.value : "")), E(e, (i) => {
      s(i);
    }), (i, l) => (n(), a("label", qe, [
      U(t("input", {
        type: "checkbox",
        class: "theme-controller",
        "onUpdate:modelValue": l[0] || (l[0] = (p) => Te(e) ? e.value = p : null),
        "true-value": u.lightTheme,
        "false-value": u.darkTheme
      }, null, 8, Ye), [
        [Me, V(e)]
      ]),
      W(V(Fe), { class: "swap-off fill-current" }),
      W(V(Re), { class: "swap-on fill-current" })
    ]));
  }
}), Je = ["name"], We = { class: "collapse-title font-bold text-2xl lg:text-4xl" }, Xe = { class: "collapse-content" }, Ze = ["innerHTML"], _n = /* @__PURE__ */ M({
  __name: "accordion",
  props: {
    name: {},
    items: {},
    joinItems: { type: Boolean, default: !1 },
    icon: {}
  },
  setup(d) {
    const u = d;
    return (e, s) => (n(!0), a(y, null, _(u.items, (i, l) => (n(), a("div", {
      class: $(["collapse border border-base-300", [e.icon ? `collapse-${e.icon}` : "", { "join-item": e.joinItems }]]),
      key: l
    }, [
      t("input", {
        type: "radio",
        name: e.name,
        value: "true"
      }, null, 8, Je),
      t("div", We, b(i.title), 1),
      t("div", Xe, [
        t("span", {
          innerHTML: i.content
        }, null, 8, Ze)
      ])
    ], 2))), 128));
  }
}), Ke = {
  key: 0,
  class: "rounded-sm"
}, Ge = ["src"], Qe = {
  key: 1,
  class: "flex justify-center bg-neutral p-[25%] rounded-full w-16 text-neutral-content text-center"
}, et = { class: "text-xl" }, kn = /* @__PURE__ */ M({
  __name: "avatar",
  props: {
    image: {},
    onlineStatus: { default: "none" },
    initials: {}
  },
  setup(d) {
    const u = d, e = k(u.onlineStatus);
    return E(
      () => u.onlineStatus,
      (s) => {
        s && (e.value = s);
      }
    ), (s, i) => (n(), a("div", {
      class: $(["avatar", `avatar-${s.onlineStatus}`])
    }, [
      s.image ? (n(), a("div", Ke, [
        t("img", {
          src: s.image,
          class: "w-full h-full"
        }, null, 8, Ge)
      ])) : (n(), a("div", Qe, [
        t("p", et, b(s.initials), 1)
      ]))
    ], 2));
  }
}), $n = /* @__PURE__ */ M({
  __name: "badge",
  props: {
    color: { default: "neutral" },
    outline: { type: Boolean, default: !1 },
    size: { default: "medium" }
  },
  setup(d) {
    const u = d, e = {
      "extra small": "badge-xs",
      small: "badge-sm",
      medium: "badge-md",
      large: "badge-lg"
    }, s = {
      neutral: "badge-neutral",
      primary: "badge-primary",
      secondary: "badge-secondary",
      accent: "badge-accent",
      ghost: "badge-ghost",
      info: "badge-info",
      success: "badge-success",
      warning: "badge-warning",
      error: "badge-error"
    };
    return (i, l) => (n(), a("span", {
      class: $(["badge", e[u.size], s[u.color], { "badge-outline": u.outline }])
    }, [
      w(i.$slots, "default")
    ], 2));
  }
}), tt = ["src", "alt"], nt = {
  key: 1,
  class: "w-full h-32 skeleton"
}, at = {
  key: 0,
  class: "card-body"
}, ot = {
  key: 0,
  class: "group-hover:text-primary text-left text-lg cursor-pointer card-title"
}, st = {
  key: 1,
  class: "text-left"
}, lt = { class: "flex-col flex-nowrap mt-auto card-actions" }, rt = {
  key: 1,
  class: "card-body"
}, Cn = /* @__PURE__ */ M({
  __name: "card",
  props: {
    imgUrl: { default: "" },
    alt: { default: "A beautiful picture that says something about this card" },
    title: { default: "" },
    description: { default: "" },
    outlined: { type: Boolean, default: !1 },
    loading: { type: Boolean, default: !1 },
    class: { default: "" }
  },
  setup(d) {
    const u = d, e = k(u.outlined);
    return E(
      () => u.outlined,
      (s) => {
        e.value = s;
      }
    ), (s, i) => (n(), a("div", {
      class: $(["bg-base-100 shadow-xl rounded-sm min-w-64 max-w-full h-full card card-compact group", e.value ? "border-4 border-primary" : ""])
    }, [
      t("figure", null, [
        s.imgUrl || s.imgUrl && !s.loading ? (n(), a("img", {
          key: 0,
          src: s.imgUrl,
          alt: s.alt,
          class: $(["rounded-sm w-full h-44 object-cover", {
            hidden: s.loading
          }])
        }, null, 10, tt)) : x("", !0),
        s.loading && s.imgUrl ? (n(), a("div", nt)) : x("", !0)
      ]),
      s.loading ? x("", !0) : (n(), a("div", at, [
        s.title ? (n(), a("h2", ot, b(s.title), 1)) : x("", !0),
        w(s.$slots, "details"),
        s.description ? (n(), a("p", st, b(s.description), 1)) : x("", !0),
        t("div", lt, [
          w(s.$slots, "actions")
        ])
      ])),
      s.loading ? (n(), a("div", rt, i[0] || (i[0] = [
        t("div", { class: "flex flex-col gap-4 w-52" }, [
          t("div", { class: "w-28 h-4 skeleton" }),
          t("div", { class: "w-full h-4 skeleton" }),
          t("div", { class: "w-full h-4 skeleton" })
        ], -1)
      ]))) : x("", !0)
    ], 2));
  }
}), it = { class: "flex gap-4 bg-base-100 w-full tabs tabs-boxed" }, ut = ["onClick"], dt = { class: "text-sm" }, ct = { class: "md:block hidden opacity-35 text-xs truncate overflow-hidden ..." }, pt = { class: "hidden" }, mt = {
  id: "advancedSearchMobile",
  class: "modal"
}, vt = { class: "modal-box" }, ft = { class: "font-bold text-lg" }, gt = ["checked"], ht = { class: "flex justify-between items-center pr-4 w-full font-medium text-xl collapse-title" }, bt = { class: "text-sm" }, yt = { class: "flex place-content-center p-0 collapse-content" }, wt = /* @__PURE__ */ M({
  __name: "advancedSearch",
  props: {
    searchOptions: {},
    currentCategory: {}
  },
  emits: ["search", "update:search-data"],
  setup(d, { emit: u }) {
    const e = d, s = u, i = k(null), l = {
      datetime: Be(() => Promise.resolve().then(() => Ht))
    }, p = k({}), h = k({ left: "0px", top: "0px", transform: "translateX(0%)" }), f = k(null);
    function m(C, I) {
      var B, O, g;
      if ((B = i.value) != null && B.name) {
        s("update:search-data", {
          tab: i.value.name,
          data: C
        });
        return;
      }
      if (e.searchOptions) {
        let D = (g = (O = e.searchOptions) == null ? void 0 : O.find((A) => (A == null ? void 0 : A.category) === e.currentCategory)) == null ? void 0 : g.tabs[I];
        D !== void 0 && (D.value = C, s("update:search-data", {
          tab: D == null ? void 0 : D.name,
          data: D == null ? void 0 : D.value
        }));
      }
    }
    function v() {
      s("search");
    }
    async function z(C) {
      f.value && !f.value.contains(C.target) && (await de(), i.value = null);
    }
    async function Z() {
      if (typeof window < "u" && window.innerWidth <= 768) {
        const C = document.getElementById("advancedSearchMobile");
        C ? C.showModal() : console.warn("Modal element not found.");
      }
    }
    async function K(C) {
      var B;
      i.value = C, await de();
      const I = p.value[C.name];
      if (I) {
        const O = I.getBoundingClientRect(), g = ((B = f.value) == null ? void 0 : B.getBoundingClientRect()) || { left: 0, top: 0 };
        window.innerWidth > 768 ? h.value = {
          left: `${O.left + O.width / 2 - g.left}px`,
          top: `${O.bottom - g.top}px`,
          transform: "translateX(-50%)"
        } : h.value = {
          left: "50%",
          top: `${O.bottom - g.top}px`,
          transform: "translateX(-50%)"
          // Center the popup horizontally on mobile
        };
      } else
        console.error("Tab element not found for:", C.name);
    }
    return F(() => {
      document.addEventListener("click", z);
    }), Ie(() => {
      document.removeEventListener("click", z);
    }), (C, I) => {
      var B, O;
      return n(), a(y, null, [
        t("div", {
          ref_key: "searchContainer",
          ref: f,
          class: "w-full"
        }, [
          t("div", {
            class: "group/search relative flex place-items-center border-2 shadow-md p-2 border-base-300/25 rounded-sm w-full transition-all cursor-pointer md:cursor-auto",
            onClick: Z
          }, [
            t("div", it, [
              (n(!0), a(y, null, _(((B = e.searchOptions.find((g) => g.category === e.currentCategory)) == null ? void 0 : B.tabs) || [], (g) => {
                var D;
                return n(), a("button", {
                  key: g.name,
                  onClick: (A) => K(g),
                  class: $([{ "tab-active": ((D = i.value) == null ? void 0 : D.name) === g.name }, "group/searchitem relative after:top-0 after:-right-2 after:absolute first-of-type:flex-auto last-of-type:flex-auto md:after:content-[''] last-of-type:after:content-none after:content-none after:bg-base-200 hover:bg-base-200 p-1 rounded-sm w-auto after:w-[1px] after:h-10 text-start overflow-x-hidden pointer-events-none md:pointer-events-auto"]),
                  ref_for: !0,
                  ref: (A) => p.value[g.name] = A
                }, [
                  t("p", dt, b(g.name), 1),
                  t("p", ct, b(g.description), 1)
                ], 10, ut);
              }), 128))
            ]),
            i.value ? (n(), a("div", {
              key: 0,
              class: "absolute flex shadow-sm mt-4 w-fit max-w-full transition-all tab-content",
              style: Oe(h.value)
            }, [
              (n(), re(ie(l[i.value.type]), ue(i.value.props ? i.value.props : null, { onUpdated: m }), null, 16))
            ], 4)) : x("", !0),
            t("button", {
              title: "search",
              type: "submit",
              class: "ml-1 btn btn-primary btn-square",
              onClick: v
            }, [
              W(V(ce), {
                size: 24,
                color: "white"
              })
            ])
          ]),
          t("div", pt, [
            t("button", {
              title: "search",
              onClick: I[0] || (I[0] = () => {
              })
            }, [
              W(V(ce), {
                size: 24,
                color: "white"
              })
            ])
          ])
        ], 512),
        t("dialog", mt, [
          t("div", vt, [
            w(C.$slots, "additionalForMobile", {}, () => [
              t("h3", ft, b(C.currentCategory), 1)
            ], !0),
            (n(!0), a(y, null, _(((O = e.searchOptions.find((g) => g.category === e.currentCategory)) == null ? void 0 : O.tabs) || [], (g, D) => (n(), a("div", {
              class: "bg-base-200 my-4 collapse",
              key: g.name
            }, [
              t("input", {
                type: "radio",
                name: "my-accordion-1",
                checked: D === 0
              }, null, 8, gt),
              t("div", ht, [
                ne(b(g.name) + " ", 1),
                t("p", bt, b(g.description), 1)
              ]),
              t("div", yt, [
                I[1] || (I[1] = t("br", null, null, -1)),
                (n(), re(ie(l[g.type]), ue({ ref_for: !0 }, g.props || {}, {
                  onUpdated: (A) => m(A, D)
                }), null, 16, ["onUpdated"]))
              ])
            ]))), 128)),
            t("div", { class: "modal-action" }, [
              t("form", { method: "dialog" }, [
                t("button", {
                  class: "btn btn-primary",
                  onClick: v
                }, "Close and Search")
              ])
            ])
          ])
        ])
      ], 64);
    };
  }
}), X = (d, u) => {
  const e = d.__vccOpts || d;
  for (const [s, i] of u)
    e[s] = i;
  return e;
}, Sn = /* @__PURE__ */ X(wt, [["__scopeId", "data-v-08fa37eb"]]), _t = ["placeholder", "value", "id"], kt = ["id"], $t = {
  key: 0,
  class: "flex justify-between items-center place-content-center mb-4"
}, Ct = ["value"], St = ["value"], xt = {
  key: 1,
  class: "gap-2 grid grid-cols-7"
}, Dt = ["onClick"], Tt = {
  key: 2,
  class: "mt-4 lg:w-80"
}, Mt = {
  key: 0,
  class: "mb-2 font-bold text-lg"
}, Bt = { key: 1 }, It = {
  key: 1,
  class: "flex gap-4"
}, Ot = ["value"], Ut = ["value"], Vt = {
  key: 2,
  class: "flex flex-col gap-4"
}, At = {
  key: 1,
  class: "flex gap-2"
}, Pt = ["value"], jt = ["value"], zt = {
  key: 1,
  class: "flex gap-2"
}, Nt = ["value"], Et = ["value"], Lt = { class: "flex gap-2 mt-4" }, Rt = {
  __name: "datetimePicker",
  props: {
    mode: {
      type: String,
      default: "datetime",
      // 'datetime', 'date', 'time'
      validator: (d) => ["datetime", "date", "time"].includes(d)
    },
    range: {
      type: Boolean,
      default: !1
    },
    placeholder: {
      type: String,
      default: "Select date and time"
    },
    popup: {
      type: Boolean,
      default: !1
    },
    id: {
      type: String,
      default: "datetimepicker"
    },
    initialDate: {
      type: Object,
      default: () => null
    }
  },
  emits: ["updated"],
  setup(d, { emit: u }) {
    const e = d;
    E(() => e.range, (r) => {
      r ? (l.value = { start: null, end: null }, p.value = { start: null, end: null }) : (l.value = null, p.value = null);
    });
    const s = u, i = k(!1), l = k(e.range ? { start: null, end: null } : null), p = k(e.range ? { start: null, end: null } : null), h = k((/* @__PURE__ */ new Date()).toLocaleString("default", { month: "long" })), f = k((/* @__PURE__ */ new Date()).getFullYear()), m = k(e.range ? { start: 0, end: 0 } : 0), v = k(e.range ? { start: 0, end: 0 } : 0), z = k(null), Z = S(() => `${e.id}-input`), K = S(() => `${e.id}-popup`), C = S(() => e.mode === "date" || e.mode === "datetime"), I = S(() => e.mode === "time" || e.mode === "datetime");
    S(() => new Date(f.value, B.value));
    const B = S(() => q.indexOf(h.value)), O = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], g = S(() => new Date(f.value, B.value).getDay()), D = S(() => {
      const r = new Date(f.value, B.value + 1, 0).getDate();
      return Array.from({ length: r }, (c, o) => new Date(f.value, B.value, o + 1));
    }), A = S(() => Array.from({ length: g.value }, (r, c) => c)), G = Array.from({ length: 24 }, (r, c) => c), Q = Array.from({ length: 60 }, (r, c) => c), H = S(
      () => typeof navigator < "u" && /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
        navigator.userAgent
      )
    ), q = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], me = S(() => {
      const r = (/* @__PURE__ */ new Date()).getFullYear();
      return Array.from({ length: 100 }, (c, o) => r - 50 + o);
    }), ve = S(() => {
      if (!C.value || !l.value) return "";
      if (e.range && l.value.start && l.value.end) {
        const r = l.value.start.toLocaleDateString("en-US"), c = l.value.end.toLocaleDateString("en-US");
        return `${r} - ${c}`;
      }
      return !e.range && l.value ? l.value.toLocaleDateString("en-US") : "";
    }), L = (r) => r instanceof Date ? r : new Date(r), N = (r) => r instanceof Date && !isNaN(r), fe = S(() => {
      if (!I.value) return "";
      const r = (c) => {
        var Y, R, le;
        const o = ((Y = m.value) == null ? void 0 : Y[c]) ?? m.value, P = ((R = v.value) == null ? void 0 : R[c]) ?? v.value;
        return H.value ? ((le = p.value) == null ? void 0 : le[c]) ?? p.value : `${o.toString().padStart(2, "0")}:${P.toString().padStart(2, "0")}`;
      };
      return e.range ? `${r("start")} - ${r("end")}` : r();
    }), ge = S(() => {
      const r = ve.value, c = fe.value;
      return `${r} ${c}`.trim();
    }), he = () => i.value = !i.value, oe = () => {
      T(), be();
    }, be = () => i.value = !1, ye = () => {
      l.value = e.range ? { start: null, end: null } : null, p.value = e.range ? { start: null, end: null } : null, T();
    }, we = (r) => {
      e.range ? l.value.start && l.value.end ? l.value = { start: r, end: null } : l.value.start ? l.value.end = r : l.value.start = r : l.value = r, T();
    }, _e = (r) => (r = L(r), e.range ? l.value.start && N(l.value.start) && r.getTime() === l.value.start.getTime() || l.value.end && N(l.value.end) && r.getTime() === l.value.end.getTime() : N(l.value) && r.getTime() === l.value.getTime()), ke = (r) => {
      r = L(r);
      const c = /* @__PURE__ */ new Date();
      return r.getDate() === c.getDate() && r.getMonth() === c.getMonth() && r.getFullYear() === c.getFullYear();
    }, $e = (r) => (r = L(r), e.range && N(l.value.start) && r.getTime() === l.value.start.getTime()), Ce = (r) => (r = L(r), e.range && N(l.value.end) && r.getTime() === l.value.end.getTime()), Se = (r) => {
      if (r = L(r), e.range && N(l.value.start) && N(l.value.end)) {
        const c = l.value.start.getTime(), o = l.value.end.getTime(), P = r.getTime();
        return P > c && P < o;
      }
      return !1;
    }, xe = () => {
      let r = B.value - 1;
      r < 0 && (r = 11, f.value--), h.value = q[r], T();
    }, De = () => {
      let r = B.value + 1;
      r > 11 && (r = 0, f.value++), h.value = q[r], T();
    }, se = (r) => {
      z.value && !z.value.contains(r.target) && i.value == !0 && oe();
    }, T = () => {
      let r = {};
      const c = (o, P, Y) => {
        o instanceof Date && !isNaN(o) || (o = /* @__PURE__ */ new Date());
        const R = new Date(o);
        return R.setUTCHours(P, Y, 0, 0), R.toISOString();
      };
      e.range ? (r.from = c(
        l.value.start,
        m.value.start,
        v.value.start
      ), r.to = c(
        l.value.end,
        m.value.end,
        v.value.end
      )) : r = c(
        l.value,
        m.value,
        v.value
      ), s("updated", r);
    };
    return F(() => {
      e.initialDate && (e.range && e.initialDate.start && e.initialDate.end ? l.value = {
        start: new Date(e.initialDate.start),
        end: new Date(e.initialDate.end)
      } : e.initialDate.start && (l.value = { start: new Date(e.initialDate.start) })), e.range ? (m.value.start = m.value.start ?? (/* @__PURE__ */ new Date()).getHours(), m.value.end = m.value.end ?? (/* @__PURE__ */ new Date()).getHours(), v.value.start = v.value.start ?? (/* @__PURE__ */ new Date()).getMinutes(), v.value.end = v.value.end ?? (/* @__PURE__ */ new Date()).getMinutes()) : (m.value = m.value ?? (/* @__PURE__ */ new Date()).getHours(), v.value = v.value ?? (/* @__PURE__ */ new Date()).getMinutes());
    }), e.popup && F(() => document.addEventListener("click", se)), pe(() => document.removeEventListener("click", se)), (r, c) => (n(), a("div", {
      class: "inline-block relative w-full lg:w-[360px]",
      ref_key: "pickerContainer",
      ref: z
    }, [
      t("div", {
        class: "flex items-center gap-2 cursor-pointer",
        onClick: he
      }, [
        d.popup ? w(r.$slots, "default", { key: 0 }, () => [
          t("input", {
            type: "text",
            class: "input-bordered w-full cursor-pointer input",
            placeholder: d.placeholder,
            value: ge.value,
            readonly: "",
            id: Z.value
          }, null, 8, _t),
          c[11] || (c[11] = t("button", { class: "btn btn-ghost" }, " 📅 ", -1))
        ], !0) : x("", !0)
      ]),
      i.value || !d.popup ? (n(), a("div", {
        key: 0,
        class: $(["z-50 lg:bg-base-100 md:mt-2 px-4 md:p-4 rounded-md w-full", [{ absolute: d.popup }]]),
        id: K.value
      }, [
        C.value ? (n(), a("div", $t, [
          t("button", {
            class: "md:block hidden btn btn-outline btn-primary md:btn-sm",
            onClick: xe
          }, c[12] || (c[12] = [
            t("svg", {
              xmlns: "http://www.w3.org/2000/svg",
              class: "w-4 h-4",
              fill: "none",
              viewBox: "0 0 24 24",
              stroke: "currentColor"
            }, [
              t("path", {
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                "stroke-width": "2",
                d: "M15 19l-7-7 7-7"
              })
            ], -1)
          ])),
          U(t("select", {
            class: "border-none w-fit select",
            "onUpdate:modelValue": c[0] || (c[0] = (o) => h.value = o),
            onChange: T
          }, [
            (n(), a(y, null, _(q, (o, P) => t("option", {
              key: P,
              value: o
            }, b(o), 9, Ct)), 64))
          ], 544), [
            [j, h.value]
          ]),
          U(t("select", {
            class: "border-none w-24 select",
            "onUpdate:modelValue": c[1] || (c[1] = (o) => f.value = o),
            onChange: T
          }, [
            (n(!0), a(y, null, _(me.value, (o) => (n(), a("option", {
              key: o,
              value: o
            }, b(o), 9, St))), 128))
          ], 544), [
            [j, f.value]
          ]),
          t("button", {
            class: "md:block hidden btn btn-outline btn-primary md:btn-sm",
            onClick: De
          }, c[13] || (c[13] = [
            t("svg", {
              xmlns: "http://www.w3.org/2000/svg",
              class: "w-4 h-4",
              fill: "none",
              viewBox: "0 0 24 24",
              stroke: "currentColor"
            }, [
              t("path", {
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                "stroke-width": "2",
                d: "M9 5l7 7-7 7"
              })
            ], -1)
          ]))
        ])) : x("", !0),
        C.value ? (n(), a("div", xt, [
          (n(), a(y, null, _(O, (o) => t("div", {
            key: o,
            class: "text-center"
          }, b(o), 1)), 64)),
          (n(!0), a(y, null, _(A.value, (o) => (n(), a("div", {
            key: o,
            class: "text-center"
          }))), 128)),
          (n(!0), a(y, null, _(D.value, (o) => (n(), a("div", {
            key: o,
            class: $(["hover:bg-primary-10 py-1 rounded-full text-center cursor-pointer", {
              "bg-primary text-primary-content": _e(o),
              today: ke(o),
              "range-start bg-primary text-primary-content": $e(o),
              "range-end bg-primary text-primary-content": Ce(o),
              "in-range bg-primary/20 hover:bg-primary/10": Se(o)
            }]),
            onClick: (P) => we(o)
          }, b(o.getDate()), 11, Dt))), 128))
        ])) : x("", !0),
        I.value ? (n(), a("div", Tt, [
          e.range ? x("", !0) : (n(), a("h3", Mt, "Select Time")),
          e.range ? (n(), a("div", Vt, [
            t("div", null, [
              c[14] || (c[14] = t("p", { class: "font-bold" }, "Start Time", -1)),
              H.value ? U((n(), a("input", {
                key: 0,
                type: "time",
                class: "input-bordered w-full input",
                "onUpdate:modelValue": c[5] || (c[5] = (o) => p.value.start = o),
                onChange: T
              }, null, 544)), [
                [ee, p.value.start]
              ]) : (n(), a("div", At, [
                U(t("select", {
                  class: "w-full select-bordered select",
                  "onUpdate:modelValue": c[6] || (c[6] = (o) => m.value.start = o),
                  onChange: T
                }, [
                  (n(!0), a(y, null, _(V(G), (o) => (n(), a("option", {
                    key: o,
                    value: o
                  }, b(o.toString().padStart(2, "0")), 9, Pt))), 128))
                ], 544), [
                  [
                    j,
                    m.value.start,
                    void 0,
                    { number: !0 }
                  ]
                ]),
                U(t("select", {
                  class: "w-full select-bordered select",
                  "onUpdate:modelValue": c[7] || (c[7] = (o) => v.value.start = o),
                  onChange: T
                }, [
                  (n(!0), a(y, null, _(V(Q), (o) => (n(), a("option", {
                    key: o,
                    value: o
                  }, b(o.toString().padStart(2, "0")), 9, jt))), 128))
                ], 544), [
                  [
                    j,
                    v.value.start,
                    void 0,
                    { number: !0 }
                  ]
                ])
              ]))
            ]),
            t("div", null, [
              c[15] || (c[15] = t("p", { class: "font-bold" }, "End Time", -1)),
              H.value ? U((n(), a("input", {
                key: 0,
                type: "time",
                class: "input-bordered w-full input",
                "onUpdate:modelValue": c[8] || (c[8] = (o) => p.value.end = o),
                onChange: T
              }, null, 544)), [
                [ee, p.value.end]
              ]) : (n(), a("div", zt, [
                U(t("select", {
                  class: "w-full select-bordered select",
                  "onUpdate:modelValue": c[9] || (c[9] = (o) => m.value.end = o),
                  onChange: T
                }, [
                  (n(!0), a(y, null, _(V(G), (o) => (n(), a("option", {
                    key: o,
                    value: o
                  }, b(o.toString().padStart(2, "0")), 9, Nt))), 128))
                ], 544), [
                  [
                    j,
                    m.value.end,
                    void 0,
                    { number: !0 }
                  ]
                ]),
                U(t("select", {
                  class: "w-full select-bordered select",
                  "onUpdate:modelValue": c[10] || (c[10] = (o) => v.value.end = o),
                  onChange: T
                }, [
                  (n(!0), a(y, null, _(V(Q), (o) => (n(), a("option", {
                    key: o,
                    value: o
                  }, b(o.toString().padStart(2, "0")), 9, Et))), 128))
                ], 544), [
                  [
                    j,
                    v.value.end,
                    void 0,
                    { number: !0 }
                  ]
                ])
              ]))
            ])
          ])) : (n(), a("div", Bt, [
            H.value ? U((n(), a("input", {
              key: 0,
              type: "time",
              class: "input-bordered w-full input",
              "onUpdate:modelValue": c[2] || (c[2] = (o) => p.value = o),
              onChange: T
            }, null, 544)), [
              [ee, p.value]
            ]) : (n(), a("div", It, [
              U(t("select", {
                class: "w-full select-bordered select",
                "onUpdate:modelValue": c[3] || (c[3] = (o) => m.value = o),
                onChange: T
              }, [
                (n(!0), a(y, null, _(V(G), (o) => (n(), a("option", {
                  key: o,
                  value: o
                }, b(o.toString().padStart(2, "0")), 9, Ot))), 128))
              ], 544), [
                [
                  j,
                  m.value,
                  void 0,
                  { number: !0 }
                ]
              ]),
              U(t("select", {
                class: "w-full select-bordered select",
                "onUpdate:modelValue": c[4] || (c[4] = (o) => v.value = o),
                onChange: T
              }, [
                (n(!0), a(y, null, _(V(Q), (o) => (n(), a("option", {
                  key: o,
                  value: o
                }, b(o.toString().padStart(2, "0")), 9, Ut))), 128))
              ], 544), [
                [
                  j,
                  v.value,
                  void 0,
                  { number: !0 }
                ]
              ])
            ]))
          ]))
        ])) : x("", !0),
        t("div", Lt, [
          t("button", {
            class: $(["btn btn-secondary", d.popup ? "w-fit" : "w-full"]),
            onClick: ye
          }, "Clear", 2),
          d.popup ? (n(), a("button", {
            key: 0,
            class: "btn btn-primary btn-wide",
            onClick: oe
          }, "Close")) : x("", !0)
        ])
      ], 10, kt)) : x("", !0)
    ], 512));
  }
}, Ft = /* @__PURE__ */ X(Rt, [["__scopeId", "data-v-e7e203aa"]]), Ht = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: Ft
}, Symbol.toStringTag, { value: "Module" })), qt = ["value", "checked", "onChange", "disabled"], xn = /* @__PURE__ */ M({
  __name: "rating",
  props: {
    initialRating: { default: 0 },
    numberOfStars: { default: 5 },
    halfStars: { type: Boolean, default: !0 },
    isInteractive: { type: Boolean, default: !1 },
    size: { default: "sm" }
  },
  setup(d) {
    const u = d, e = k(u.initialRating);
    E(
      () => u.initialRating,
      (i) => {
        e.value = i;
      }
    );
    const s = (i) => {
      e.value = i;
    };
    return (i, l) => (n(), a("div", {
      class: $(["rating", [
        `rating-${u.size}`,
        { "rating-half": i.halfStars }
      ]])
    }, [
      (n(!0), a(y, null, _(i.numberOfStars * (i.halfStars ? 2 : 1), (p) => (n(), a("input", {
        key: p,
        type: "radio",
        value: i.halfStars ? p * 0.5 : p,
        checked: e.value === (i.halfStars ? p * 0.5 : p),
        onChange: (h) => i.isInteractive ? s(i.halfStars ? p * 0.5 : p) : null,
        class: $(["mask mask-star", {
          "bg-yellow-400": e.value >= (i.halfStars ? p * 0.5 : p),
          "mask-half-1": i.halfStars && p % 2 !== 0,
          "mask-half-2": i.halfStars && p % 2 === 0,
          "cursor-pointer": i.isInteractive,
          "cursor-default": !i.isInteractive
        }]),
        disabled: !i.isInteractive
      }, null, 42, qt))), 128))
    ], 2));
  }
}), Yt = {
  key: 0,
  class: "loading loading-spinner loading-md mx-auto"
}, Dn = /* @__PURE__ */ M({
  __name: "loader",
  props: {
    loading: { type: Boolean, default: !0 }
  },
  setup(d) {
    const u = d, e = k(u.loading);
    return E(
      () => u.loading,
      (s) => {
        e.value = s;
      }
    ), (s, i) => e.value ? (n(), a("span", Yt)) : x("", !0);
  }
}), Jt = { class: "bg-base-200 mx-auto md:px-10 py-10 text-base-content" }, Wt = { class: "footer sm:footer-horizontal container" }, Xt = { class: "footer-title" }, Zt = ["href"], Kt = { class: "ml-auto" }, Tn = /* @__PURE__ */ M({
  __name: "footer",
  props: {
    items: {}
  },
  setup(d) {
    const u = d;
    return (e, s) => (n(), a("div", Jt, [
      t("footer", Wt, [
        (n(!0), a(y, null, _(u.items, (i) => (n(), a("nav", null, [
          t("h6", Xt, b(i.title), 1),
          (n(!0), a(y, null, _(i.items, (l) => (n(), a("a", {
            class: "link link-hover",
            href: l.link
          }, b(l.text), 9, Zt))), 256))
        ]))), 256)),
        t("aside", Kt, [
          w(e.$slots, "default")
        ])
      ])
    ]));
  }
}), Gt = {}, Qt = { class: "min-h-40 container hero" }, en = { class: "px-0! text-center hero-content" }, tn = { class: "mt-9 text-4xl" };
function nn(d, u) {
  return n(), a("div", Qt, [
    t("div", en, [
      t("div", null, [
        t("h1", tn, [
          w(d.$slots, "title", {}, () => [
            u[0] || (u[0] = ne("hero title"))
          ])
        ]),
        t("p", null, [
          w(d.$slots, "description", { class: "py-9" })
        ]),
        w(d.$slots, "call-to-action-block", { class: "max-w-full" }, () => [
          u[1] || (u[1] = t("button", { class: "btn btn-primary" }, "Call to action", -1))
        ])
      ])
    ])
  ]);
}
const Mn = /* @__PURE__ */ X(Gt, [["render", nn]]), an = { class: "categories flex flex-row gap-4 place-content-center" }, on = ["onClick"], Bn = /* @__PURE__ */ M({
  __name: "categoryNavigation",
  props: {
    searchOptions: {},
    currentCategory: {}
  },
  emits: ["update:currentCategory"],
  setup(d, { emit: u }) {
    const e = d, s = u;
    function i(l) {
      s("update:currentCategory", l);
    }
    return (l, p) => (n(), a("div", an, [
      (n(!0), a(y, null, _(e.searchOptions, (h) => (n(), a("div", {
        key: h.category
      }, [
        t("button", {
          onClick: (f) => i(h.category),
          class: $(["truncate", { "font-semibold": e.currentCategory === h.category }])
        }, b(h.category), 11, on)
      ]))), 128))
    ]));
  }
}), sn = { class: "md:flex hidden navbar-start" }, ln = { class: "md:flex justify-center items-center hidden navbar-center" }, rn = { class: "md:flex hidden navbar-end" }, un = { class: "navbar-bottom md:flex hidden" }, dn = /* @__PURE__ */ M({
  __name: "navigationBar",
  props: {
    isCollapsed: { type: Boolean, default: !0 }
  },
  setup(d) {
    const u = d;
    return (e, s) => (n(), a("nav", {
      class: $(["place-items-start border-primary bg-base-100 px-5 py-5 border-b-4 transition-all navbar navigationbar", u.isCollapsed ? "collapsed" : ""])
    }, [
      t("div", sn, [
        w(e.$slots, "start", {}, void 0, !0)
      ]),
      t("div", ln, [
        w(e.$slots, "center", {}, void 0, !0)
      ]),
      t("div", rn, [
        w(e.$slots, "end", {}, void 0, !0)
      ]),
      t("div", un, [
        w(e.$slots, "bottom", {}, void 0, !0)
      ])
    ], 2));
  }
}), In = /* @__PURE__ */ X(dn, [["__scopeId", "data-v-8ddb2b45"]]), cn = {
  role: "tablist",
  class: "tabs tabs-bordered tabs-lg mt-28 relative w-full"
}, pn = {
  key: 0,
  class: "hidden md:flex gap-4 right-0 top-4 absolute"
}, mn = ["onClick", "aria-selected"], vn = {
  role: "tabpanel",
  class: "tab-content border-base-300 border-t-2 border-x-0 border-b-0 p-6 overflow-x-auto max-w-full"
}, On = /* @__PURE__ */ M({
  __name: "tab",
  props: {
    items: {},
    withControlls: { type: Boolean },
    rotateTabsAfter: {}
  },
  emits: ["tab-changed"],
  setup(d, { emit: u }) {
    const e = d, s = k(e.items[0]), i = u;
    function l(f) {
      s.value = f, i("tab-changed", f);
    }
    function p() {
      const m = (e.items.indexOf(s.value) + 1) % e.items.length;
      l(e.items[m]);
    }
    function h() {
      const m = (e.items.indexOf(s.value) - 1 + e.items.length) % e.items.length;
      l(e.items[m]);
    }
    return pe(() => {
      e.rotateTabsAfter && setInterval(() => {
        p();
      }, e.rotateTabsAfter * 1e3);
    }), (f, m) => (n(), a("div", cn, [
      f.withControlls ? (n(), a("div", pn, [
        t("button", {
          onClick: m[0] || (m[0] = (v) => h()),
          class: "cursor-pointer"
        }, "Previous"),
        t("button", {
          onClick: m[1] || (m[1] = (v) => p()),
          class: "cursor-pointer text-primary"
        }, "Next")
      ])) : x("", !0),
      (n(!0), a(y, null, _(f.items, (v) => (n(), a(y, null, [
        t("a", {
          type: "button",
          role: "tab",
          class: $(["tab min-w-max", v === s.value ? "bg-primary text-base-100" : ""]),
          onClick: (z) => l(v),
          "aria-selected": s.value == v
        }, b(v), 11, mn),
        t("div", vn, [
          w(f.$slots, `${v}-tab`)
        ])
      ], 64))), 256))
    ]));
  }
});
export {
  _n as Accordion,
  Sn as AdvancedSearch,
  kn as Avatar,
  $n as Badge,
  gn as ButtonComponent,
  Cn as Card,
  Bn as CategoryNavigation,
  Ft as DatetimePicker,
  hn as Dropdown,
  Tn as Footer,
  Mn as Hero,
  Dn as Loader,
  bn as Modal,
  In as NavigationBar,
  xn as Rating,
  yn as Swap,
  On as Tab,
  wn as ThemeController
};
